/*
   This program should evaluate (interpret) an Abstract Syntax Tree (AST)
   that is defined by the following grammar.

        Exp ::= AExp | BExp

       AExp ::= '(' BinOp AExp AExp ')'
              | '(' '+' AExp+ ')'
              | '(' '-' AExp AExp ')'
              | '(' '-' AExp ')'
              | '(' '*' AExp AExp+ ')'
              | INTEGER

     BinOp  ::= '\' | ' %' | '^'

       BExp ::= '(' BoolOp BExp BExp+ ')'
              | '(' '!' BExp ')'
              | '(' RelOp  AExp AExp ')'
              | BOOLEAN

     BoolOp ::= '&&' | '||'
     RelOp  ::= '<' | '>' | '<=' | '>=' | '==' | '!='

    INTEGER ::= [0-9]+
    BOOLEAN ::= 'true' | 'false'


   Notice that the '+' operator can take any number of inputs (i.e., one or more).
   Notice that the '-' operator can take one or two inputs.
   Notice that the '*', '&&', and '||' operators can take two or more inputs.

   The boolean '&&' and '||' operators should be short circuited.

   Notice that the result of evaluating an Exp is either an integer value or a boolean value.

   Notice that the language of arithmetic and boolean expressions is a subset
   of the language of trees (i.e., cs502-language-hw1).
*/

public class Evaluate
{
   /**
      The methods evaluate(), evaluateA(), evaluateB(), and evaluateR() are
      essentially a post-order traversal of the abstract syntax tree.
   */
   public static Value evaluate(Tree tree)
   {
      Value result = null;


      // implement this method


      return result;
   }//evaluate()


   // Evaluate an arithmetic expression
   private static Value evaluateA(Tree tree)
   {
      int result = 0;


      // implement this method


      return new Value( "int", result );
   }//evaluateA()


   // Evaluate a boolean expression
   private static Value evaluateB(Tree tree)
   {
      boolean result = false;


      // implement this method


      return new Value( "bool", result );
   }//evaluateB()


   // Evaluate a relational expression (which is a kind of boolean expression)
   private static Value evaluateR(Tree tree)
   {
      boolean result = false;


      // implement this method


      return new Value( "bool", result );
   }//evaluateR()

}//Evaluate